diff --git a/sys/dev/netif/ath/ath_hal/ah_regdomain/ah_rd_regenum.h b/sys/dev/netif/ath/ath_hal/ah_regdomain/ah_rd_regenum.h
index d8d211e..bc569cb 100644
--- a/sys/dev/netif/ath/ath_hal/ah_regdomain/ah_rd_regenum.h
+++ b/sys/dev/netif/ath/ath_hal/ah_regdomain/ah_rd_regenum.h
@@ -51,7 +51,6 @@ enum {
 	FCC2_FCCA	= 0x20,		/* Canada */
 	FCC2_WORLD	= 0x21,		/* Australia & HK */
 	FCC2_ETSIC	= 0x22,
-	FCC_UBNT	= 0x2A,		/* Ubiquity PicoStation M2HP */
 	FRANCE_RES	= 0x31,		/* Legacy France for OEM */
 	FCC3_FCCA	= 0x3A,		/* USA & Canada w/5470 band, 11h, DFS enabled */
 	FCC3_WORLD	= 0x3B,		/* USA & Canada w/5470 band, 11h, DFS enabled */
diff --git a/sys/dev/netif/ath/ath_hal/ar5210/ar5210.h b/sys/dev/netif/ath/ath_hal/ar5210/ar5210.h
index 3e372f7..48ccc20 100644
--- a/sys/dev/netif/ath/ath_hal/ar5210/ar5210.h
+++ b/sys/dev/netif/ath/ath_hal/ar5210/ar5210.h
@@ -108,6 +108,7 @@ struct ath_hal_5210 {
 	uint32_t	ah_txDescInterruptMask;
 	uint32_t	ah_txEolInterruptMask;
 	uint32_t	ah_txUrnInterruptMask;
+	HAL_POWER_MODE	ah_powerMode;
 	uint8_t		ah_bssid[IEEE80211_ADDR_LEN];
 	HAL_TX_QUEUE_INFO ah_txq[HAL_NUM_TX_QUEUES]; /* beacon+cab+data */
 	/*
@@ -120,8 +121,6 @@ struct ath_hal_5210 {
 	u_int		ah_slottime;		/* user-specified slot time */
 	u_int		ah_acktimeout;		/* user-specified ack timeout */
 	u_int		ah_ctstimeout;		/* user-specified cts timeout */
-
-	uint16_t	ah_associd;		/* association id */
 };
 #define	AH5210(ah)	((struct ath_hal_5210 *)(ah))
 
diff --git a/sys/dev/netif/ath/ath_hal/ar5210/ar5210_attach.c b/sys/dev/netif/ath/ath_hal/ar5210/ar5210_attach.c
index ee11ce9..3c0ed71 100644
--- a/sys/dev/netif/ath/ath_hal/ar5210/ar5210_attach.c
+++ b/sys/dev/netif/ath/ath_hal/ar5210/ar5210_attach.c
@@ -219,7 +219,7 @@ ar5210Attach(uint16_t devid, HAL_SOFTC sc, HAL_BUS_TAG st, HAL_BUS_HANDLE sh,
 	AH_PRIVATE(ah)->ah_powerLimit = AR5210_MAX_RATE_POWER;
 	AH_PRIVATE(ah)->ah_tpScale = HAL_TP_SCALE_MAX;	/* no scaling */
 
-	ah->ah_powerMode = HAL_PM_UNDEFINED;
+	ahp->ah_powerMode = HAL_PM_UNDEFINED;
 	ahp->ah_staId1Defaults = 0;
 	ahp->ah_rssiThr = INIT_RSSI_THR;
 	ahp->ah_sifstime = (u_int) -1;
diff --git a/sys/dev/netif/ath/ath_hal/ar5210/ar5210_misc.c b/sys/dev/netif/ath/ath_hal/ar5210/ar5210_misc.c
index 5eaa18e..8170880 100644
--- a/sys/dev/netif/ath/ath_hal/ar5210/ar5210_misc.c
+++ b/sys/dev/netif/ath/ath_hal/ar5210/ar5210_misc.c
@@ -315,7 +315,6 @@ ar5210WriteAssocid(struct ath_hal *ah, const uint8_t *bssid, uint16_t assocId)
 
 	/* XXX save bssid for possible re-use on reset */
 	OS_MEMCPY(ahp->ah_bssid, bssid, IEEE80211_ADDR_LEN);
-	ahp->ah_associd = assocId;
 	OS_REG_WRITE(ah, AR_BSS_ID0, LE_READ_4(ahp->ah_bssid));
 	OS_REG_WRITE(ah, AR_BSS_ID1, LE_READ_2(ahp->ah_bssid+4) |
 				     ((assocId & 0x3fff)<<AR_BSS_ID1_AID_S));
diff --git a/sys/dev/netif/ath/ath_hal/ar5210/ar5210_power.c b/sys/dev/netif/ath/ath_hal/ar5210/ar5210_power.c
index ec5e75d..1c6909b 100644
--- a/sys/dev/netif/ath/ath_hal/ar5210/ar5210_power.c
+++ b/sys/dev/netif/ath/ath_hal/ar5210/ar5210_power.c
@@ -93,6 +93,7 @@ ar5210SetPowerModeSleep(struct ath_hal *ah, int setChip)
 HAL_BOOL
 ar5210SetPowerMode(struct ath_hal *ah, HAL_POWER_MODE mode, int setChip)
 {
+	struct ath_hal_5210 *ahp = AH5210(ah);
 #ifdef AH_DEBUG
 	static const char* modes[] = {
 		"AWAKE",
@@ -104,30 +105,25 @@ ar5210SetPowerMode(struct ath_hal *ah, HAL_POWER_MODE mode, int setChip)
 	int status = AH_TRUE;
 
 	HALDEBUG(ah, HAL_DEBUG_POWER, "%s: %s -> %s (%s)\n", __func__,
-		modes[ah->ah_powerMode], modes[mode],
+		modes[ahp->ah_powerMode], modes[mode],
 		setChip ? "set chip " : "");
 	switch (mode) {
 	case HAL_PM_AWAKE:
-		if (setChip)
-			ah->ah_powerMode = mode;
 		status = ar5210SetPowerModeAwake(ah, setChip);
 		break;
 	case HAL_PM_FULL_SLEEP:
 		ar5210SetPowerModeSleep(ah, setChip);
-		if (setChip)
-			ah->ah_powerMode = mode;
 		break;
 	case HAL_PM_NETWORK_SLEEP:
 		ar5210SetPowerModeAuto(ah, setChip);
-		if (setChip)
-			ah->ah_powerMode = mode;
 		break;
 	default:
 		HALDEBUG(ah, HAL_DEBUG_ANY, "%s: unknown power mode %u\n",
 		    __func__, mode);
 		return AH_FALSE;
 	}
-	return status;
+	ahp->ah_powerMode = mode;
+	return status; 
 }
 
 HAL_POWER_MODE
diff --git a/sys/dev/netif/ath/ath_hal/ar5210/ar5210_reset.c b/sys/dev/netif/ath/ath_hal/ar5210/ar5210_reset.c
index 1dba729..1d50f99 100644
--- a/sys/dev/netif/ath/ath_hal/ar5210/ar5210_reset.c
+++ b/sys/dev/netif/ath/ath_hal/ar5210/ar5210_reset.c
@@ -152,12 +152,8 @@ ar5210Reset(struct ath_hal *ah, HAL_OPMODE opmode,
 	/* Restore previous led state */
 	OS_REG_WRITE(ah, AR_PCICFG, OS_REG_READ(ah, AR_PCICFG) | ledstate);
 
-#if 0
 	OS_REG_WRITE(ah, AR_BSS_ID0, LE_READ_4(ahp->ah_bssid));
 	OS_REG_WRITE(ah, AR_BSS_ID1, LE_READ_2(ahp->ah_bssid + 4));
-#endif
-	/* BSSID, association id, ps-poll */
-	ar5210WriteAssocid(ah, ahp->ah_bssid, ahp->ah_associd);
 
 	OS_REG_WRITE(ah, AR_TXDP0, 0);
 	OS_REG_WRITE(ah, AR_TXDP1, 0);
diff --git a/sys/dev/netif/ath/ath_hal/ar5211/ar5211.h b/sys/dev/netif/ath/ath_hal/ar5211/ar5211.h
index 6f04624..c50531e 100644
--- a/sys/dev/netif/ath/ath_hal/ar5211/ar5211.h
+++ b/sys/dev/netif/ath/ath_hal/ar5211/ar5211.h
@@ -119,6 +119,7 @@ struct ath_hal_5211 {
 	uint32_t	ah_txEolInterruptMask;
 	uint32_t	ah_txUrnInterruptMask;
 	HAL_TX_QUEUE_INFO ah_txq[HAL_NUM_TX_QUEUES];
+	HAL_POWER_MODE	ah_powerMode;
 	HAL_ANT_SETTING ah_diversityControl;	/* antenna setting */
 	uint32_t	ah_calibrationTime;
 	HAL_BOOL	ah_bIQCalibration;
diff --git a/sys/dev/netif/ath/ath_hal/ar5211/ar5211_power.c b/sys/dev/netif/ath/ath_hal/ar5211/ar5211_power.c
index e646d90..776cfb3 100644
--- a/sys/dev/netif/ath/ath_hal/ar5211/ar5211_power.c
+++ b/sys/dev/netif/ath/ath_hal/ar5211/ar5211_power.c
@@ -95,6 +95,7 @@ ar5211SetPowerModeNetworkSleep(struct ath_hal *ah, int setChip)
 HAL_BOOL
 ar5211SetPowerMode(struct ath_hal *ah, HAL_POWER_MODE mode, int setChip)
 {
+	struct ath_hal_5211 *ahp = AH5211(ah);
 #ifdef AH_DEBUG
 	static const char* modes[] = {
 		"AWAKE",
@@ -106,30 +107,25 @@ ar5211SetPowerMode(struct ath_hal *ah, HAL_POWER_MODE mode, int setChip)
 	int status = AH_TRUE;
 
 	HALDEBUG(ah, HAL_DEBUG_POWER, "%s: %s -> %s (%s)\n", __func__,
-		modes[ah->ah_powerMode], modes[mode],
+		modes[ahp->ah_powerMode], modes[mode],
 		setChip ? "set chip " : "");
 	switch (mode) {
 	case HAL_PM_AWAKE:
-		if (setChip)
-			ah->ah_powerMode = mode;
 		status = ar5211SetPowerModeAwake(ah, setChip);
 		break;
 	case HAL_PM_FULL_SLEEP:
 		ar5211SetPowerModeSleep(ah, setChip);
-		if (setChip)
-			ah->ah_powerMode = mode;
 		break;
 	case HAL_PM_NETWORK_SLEEP:
 		ar5211SetPowerModeNetworkSleep(ah, setChip);
-		if (setChip)
-			ah->ah_powerMode = mode;
 		break;
 	default:
 		HALDEBUG(ah, HAL_DEBUG_ANY, "%s: unknown power mode %u\n",
 		    __func__, mode);
 		return AH_FALSE;
 	}
-	return status;
+	ahp->ah_powerMode = mode;
+	return status; 
 }
 
 HAL_POWER_MODE
diff --git a/sys/dev/netif/ath/ath_hal/ar5212/ar5212.h b/sys/dev/netif/ath/ath_hal/ar5212/ar5212.h
index 8086e71..6d38d65 100644
--- a/sys/dev/netif/ath/ath_hal/ar5212/ar5212.h
+++ b/sys/dev/netif/ath/ath_hal/ar5212/ar5212.h
@@ -270,6 +270,7 @@ struct ath_hal_5212 {
 	uint32_t	ah_intrTxqs;		/* tx q interrupt state */
 						/* decomp mask array */
 	uint8_t		ah_decompMask[HAL_DECOMP_MASK_SIZE];
+	HAL_POWER_MODE	ah_powerMode;
 	HAL_ANT_SETTING ah_antControl;		/* antenna setting */
 	HAL_BOOL	ah_diversity;		/* fast diversity setting */
 	enum {
diff --git a/sys/dev/netif/ath/ath_hal/ar5212/ar5212_power.c b/sys/dev/netif/ath/ath_hal/ar5212/ar5212_power.c
index 3068510..3f755bd 100644
--- a/sys/dev/netif/ath/ath_hal/ar5212/ar5212_power.c
+++ b/sys/dev/netif/ath/ath_hal/ar5212/ar5212_power.c
@@ -119,6 +119,7 @@ ar5212SetPowerModeNetworkSleep(struct ath_hal *ah, int setChip)
 HAL_BOOL
 ar5212SetPowerMode(struct ath_hal *ah, HAL_POWER_MODE mode, int setChip)
 {
+	struct ath_hal_5212 *ahp = AH5212(ah);
 #ifdef AH_DEBUG
 	static const char* modes[] = {
 		"AWAKE",
@@ -130,29 +131,24 @@ ar5212SetPowerMode(struct ath_hal *ah, HAL_POWER_MODE mode, int setChip)
 	int status = AH_TRUE;
 
 	HALDEBUG(ah, HAL_DEBUG_POWER, "%s: %s -> %s (%s)\n", __func__,
-		modes[ah->ah_powerMode], modes[mode],
+		modes[ahp->ah_powerMode], modes[mode],
 		setChip ? "set chip " : "");
 	switch (mode) {
 	case HAL_PM_AWAKE:
-		if (setChip)
-			ah->ah_powerMode = mode;
 		status = ar5212SetPowerModeAwake(ah, setChip);
 		break;
 	case HAL_PM_FULL_SLEEP:
 		ar5212SetPowerModeSleep(ah, setChip);
-		if (setChip)
-			ah->ah_powerMode = mode;
 		break;
 	case HAL_PM_NETWORK_SLEEP:
 		ar5212SetPowerModeNetworkSleep(ah, setChip);
-		if (setChip)
-			ah->ah_powerMode = mode;
 		break;
 	default:
 		HALDEBUG(ah, HAL_DEBUG_ANY, "%s: unknown power mode %u\n",
 		    __func__, mode);
 		return AH_FALSE;
 	}
+	ahp->ah_powerMode = mode;
 	return status;
 }
 
diff --git a/sys/dev/netif/ath/ath_hal/ar5312/ar5312_power.c b/sys/dev/netif/ath/ath_hal/ar5312/ar5312_power.c
index 7db6d80..94a0f1c 100644
--- a/sys/dev/netif/ath/ath_hal/ar5312/ar5312_power.c
+++ b/sys/dev/netif/ath/ath_hal/ar5312/ar5312_power.c
@@ -71,6 +71,7 @@ ar5312SetPowerModeNetworkSleep(struct ath_hal *ah, int setChip)
 HAL_BOOL
 ar5312SetPowerMode(struct ath_hal *ah, HAL_POWER_MODE mode, int setChip)
 {
+	struct ath_hal_5212 *ahp = AH5212(ah);
 #ifdef AH_DEBUG
 	static const char* modes[] = {
 		"AWAKE",
@@ -82,7 +83,7 @@ ar5312SetPowerMode(struct ath_hal *ah, HAL_POWER_MODE mode, int setChip)
 	int status = AH_TRUE;
 
 	HALDEBUG(ah, HAL_DEBUG_POWER, "%s: %s -> %s (%s)\n", __func__,
-		modes[ah->ah_powerMode], modes[mode],
+		modes[ahp->ah_powerMode], modes[mode],
 		setChip ? "set chip " : "");
 	switch (mode) {
 	case HAL_PM_AWAKE:
@@ -99,7 +100,7 @@ ar5312SetPowerMode(struct ath_hal *ah, HAL_POWER_MODE mode, int setChip)
 		    __func__, mode);
 		return AH_FALSE;
 	}
-	ah->ah_powerMode = mode;
+	ahp->ah_powerMode = mode;
 	return status; 
 }
 
diff --git a/sys/dev/netif/ath/ath_hal/ar5416/ar5416_attach.c b/sys/dev/netif/ath/ath_hal/ar5416/ar5416_attach.c
index bdc6111..99bab06 100644
--- a/sys/dev/netif/ath/ath_hal/ar5416/ar5416_attach.c
+++ b/sys/dev/netif/ath/ath_hal/ar5416/ar5416_attach.c
@@ -1059,11 +1059,6 @@ ar5416FillCapabilityInfo(struct ath_hal *ah)
 	if (! AH_PRIVATE(ah)->ah_ispcie)
 		pCap->halSerialiseRegWar = 1;
 
-	/*
-	 * AR5416 and later NICs support MYBEACON filtering.
-	 */
-	pCap->halRxDoMyBeacon = AH_TRUE;
-
 	return AH_TRUE;
 }
 
diff --git a/sys/dev/netif/ath/ath_hal/ar5416/ar5416_beacon.c b/sys/dev/netif/ath/ath_hal/ar5416/ar5416_beacon.c
index 6691c11..e2bf6c7 100644
--- a/sys/dev/netif/ath/ath_hal/ar5416/ar5416_beacon.c
+++ b/sys/dev/netif/ath/ath_hal/ar5416/ar5416_beacon.c
@@ -197,25 +197,6 @@ ar5416SetStaBeaconTimers(struct ath_hal *ah, const HAL_BEACON_STATE *bs)
 	 *   beacon jitter; cab timeout is max time to wait for cab
 	 *   after seeing the last DTIM or MORE CAB bit
 	 */
-
-/*
- * I've bumped these to 30TU for now.
- *
- * Some APs (AR933x/AR934x?) in 2GHz especially seem to not always
- * transmit beacon frames at exactly the right times and with it set
- * to 10TU, the NIC starts not waking up at the right times to hear
- * these slightly-larger-jitering beacons.  It also never recovers
- * from that (it doesn't resync? I'm not sure.)
- *
- * So for now bump this to 30TU.  Ideally we'd cap this based on
- * the beacon interval so the sum of CAB+BEACON timeouts never
- * exceeded the beacon interval.
- *
- * Now, since we're doing all the math in the ath(4) driver in TU
- * rather than TSF, we may be seeing the result of dumb rounding
- * errors causing the jitter to actually be a much bigger problem.
- * I'll have to investigate that with a fine tooth comb.
- */
 #define CAB_TIMEOUT_VAL     10 /* in TU */
 #define BEACON_TIMEOUT_VAL  10 /* in TU */
 #define SLEEP_SLOP          3  /* in TU */
@@ -267,13 +248,6 @@ ar5416SetStaBeaconTimers(struct ath_hal *ah, const HAL_BEACON_STATE *bs)
 
 	OS_REG_SET_BIT(ah, AR_TIMER_MODE,
 	     AR_TIMER_MODE_TBTT | AR_TIMER_MODE_TIM | AR_TIMER_MODE_DTIM);
-
-#define	HAL_TSFOOR_THRESHOLD	0x00004240 /* TSF OOR threshold (16k us) */
-
-	/* TSF out of range threshold */
-//	OS_REG_WRITE(ah, AR_TSFOOR_THRESHOLD, bs->bs_tsfoor_threshold);
-	OS_REG_WRITE(ah, AR_TSFOOR_THRESHOLD, HAL_TSFOOR_THRESHOLD);
-
 	HALDEBUG(ah, HAL_DEBUG_BEACON, "%s: next DTIM %d\n",
 	    __func__, bs->bs_nextdtim);
 	HALDEBUG(ah, HAL_DEBUG_BEACON, "%s: next beacon %d\n",
diff --git a/sys/dev/netif/ath/ath_hal/ar5416/ar5416_interrupts.c b/sys/dev/netif/ath/ath_hal/ar5416/ar5416_interrupts.c
index 32ce2ed..631ca2f 100644
--- a/sys/dev/netif/ath/ath_hal/ar5416/ar5416_interrupts.c
+++ b/sys/dev/netif/ath/ath_hal/ar5416/ar5416_interrupts.c
@@ -337,9 +337,6 @@ ar5416SetInterrupts(struct ath_hal *ah, HAL_INT ints)
 	/* Write the new IMR and store off our SW copy. */
 	HALDEBUG(ah, HAL_DEBUG_INTERRUPT, "%s: new IMR 0x%x\n", __func__, mask);
 	OS_REG_WRITE(ah, AR_IMR, mask);
-	/* Flush write */
-	(void) OS_REG_READ(ah, AR_IMR);
-
 	mask = OS_REG_READ(ah, AR_IMR_S2) & ~(AR_IMR_S2_TIM |
 					AR_IMR_S2_DTIM |
 					AR_IMR_S2_DTIMSYNC |
diff --git a/sys/dev/netif/ath/ath_hal/ar5416/ar5416_power.c b/sys/dev/netif/ath/ath_hal/ar5416/ar5416_power.c
index dff9a85..43a9241 100644
--- a/sys/dev/netif/ath/ath_hal/ar5416/ar5416_power.c
+++ b/sys/dev/netif/ath/ath_hal/ar5416/ar5416_power.c
@@ -124,6 +124,7 @@ ar5416SetPowerModeNetworkSleep(struct ath_hal *ah, int setChip)
 HAL_BOOL
 ar5416SetPowerMode(struct ath_hal *ah, HAL_POWER_MODE mode, int setChip)
 {
+	struct ath_hal_5212 *ahp = AH5212(ah);
 #ifdef AH_DEBUG
 	static const char* modes[] = {
 		"AWAKE",
@@ -133,35 +134,27 @@ ar5416SetPowerMode(struct ath_hal *ah, HAL_POWER_MODE mode, int setChip)
 	};
 #endif
 	int status = AH_TRUE;
-
-#if 0
 	if (!setChip)
 		return AH_TRUE;
-#endif
 
 	HALDEBUG(ah, HAL_DEBUG_POWER, "%s: %s -> %s (%s)\n", __func__,
-	    modes[ah->ah_powerMode], modes[mode], setChip ? "set chip " : "");
+	    modes[ahp->ah_powerMode], modes[mode], setChip ? "set chip " : "");
 	switch (mode) {
 	case HAL_PM_AWAKE:
-		if (setChip)
-			ah->ah_powerMode = mode;
 		status = ar5416SetPowerModeAwake(ah, setChip);
 		break;
 	case HAL_PM_FULL_SLEEP:
 		ar5416SetPowerModeSleep(ah, setChip);
-		if (setChip)
-			ah->ah_powerMode = mode;
 		break;
 	case HAL_PM_NETWORK_SLEEP:
 		ar5416SetPowerModeNetworkSleep(ah, setChip);
-		if (setChip)
-			ah->ah_powerMode = mode;
 		break;
 	default:
 		HALDEBUG(ah, HAL_DEBUG_ANY, "%s: unknown power mode 0x%x\n",
 		    __func__, mode);
 		return AH_FALSE;
 	}
+	ahp->ah_powerMode = mode;
 	return status;
 }
 
diff --git a/sys/dev/netif/ath/ath_hal/ar5416/ar5416reg.h b/sys/dev/netif/ath/ath_hal/ar5416/ar5416reg.h
index 29b84b1..2602353 100644
--- a/sys/dev/netif/ath/ath_hal/ar5416/ar5416reg.h
+++ b/sys/dev/netif/ath/ath_hal/ar5416/ar5416reg.h
@@ -476,10 +476,10 @@
 /* Sleep control */
 #define	AR5416_SLEEP1_ASSUME_DTIM	0x00080000
 #define	AR5416_SLEEP1_CAB_TIMEOUT	0xFFE00000	/* Cab timeout (TU) */
-#define	AR5416_SLEEP1_CAB_TIMEOUT_S	21
+#define	AR5416_SLEEP1_CAB_TIMEOUT_S	22
 
 #define	AR5416_SLEEP2_BEACON_TIMEOUT	0xFFE00000	/* Beacon timeout (TU)*/
-#define	AR5416_SLEEP2_BEACON_TIMEOUT_S	21
+#define	AR5416_SLEEP2_BEACON_TIMEOUT_S	22
 
 /* Sleep Registers */
 #define	AR_SLP32_HALFCLK_LATENCY      0x000FFFFF	/* rising <-> falling edge */
diff --git a/sys/netproto/802_11/ieee80211_power.h b/sys/netproto/802_11/ieee80211_power.h
index c23cf24..11d1737 100644
--- a/sys/netproto/802_11/ieee80211_power.h
+++ b/sys/netproto/802_11/ieee80211_power.h
@@ -73,9 +73,6 @@ int	ieee80211_node_psq_age(struct ieee80211_node *);
 int	ieee80211_pwrsave(struct ieee80211_node *, struct mbuf *);
 void	ieee80211_node_pwrsave(struct ieee80211_node *, int enable);
 void	ieee80211_sta_pwrsave(struct ieee80211vap *, int enable);
-void	ieee80211_sta_tim_notify(struct ieee80211vap *vap, int set);
-void	ieee80211_sta_ps_timer_check(struct ieee80211vap *vap);
 
-/* XXX what's this? */
 void	ieee80211_power_poll(struct ieee80211com *);
 #endif /* _NET80211_IEEE80211_POWER_H_ */
diff --git a/sys/netproto/802_11/ieee80211_proto.h b/sys/netproto/802_11/ieee80211_proto.h
index b61f6d4..198dfd0 100644
--- a/sys/netproto/802_11/ieee80211_proto.h
+++ b/sys/netproto/802_11/ieee80211_proto.h
@@ -290,8 +290,6 @@ void	ieee80211_dturbo_switch(struct ieee80211vap *, int newflags);
 void	ieee80211_swbmiss_callout(void *arg);
 void	ieee80211_beacon_miss(struct ieee80211com *);
 int	ieee80211_new_state(struct ieee80211vap *, enum ieee80211_state, int);
-int     ieee80211_new_state_locked(struct ieee80211vap *, enum ieee80211_state,
-		int);
 void	ieee80211_print_essid(const uint8_t *, int);
 void	ieee80211_dump_pkt(struct ieee80211com *,
 		const uint8_t *, int, int, int);
diff --git a/sys/netproto/802_11/ieee80211_var.h b/sys/netproto/802_11/ieee80211_var.h
index f16c97a..05a871f 100644
--- a/sys/netproto/802_11/ieee80211_var.h
+++ b/sys/netproto/802_11/ieee80211_var.h
@@ -469,8 +469,6 @@ struct ieee80211vap {
 	/* power save handling */
 	void			(*iv_update_ps)(struct ieee80211vap *, int);
 	int			(*iv_set_tim)(struct ieee80211_node *, int);
-	void			(*iv_node_ps)(struct ieee80211_node *, int);
-	void			(*iv_sta_ps)(struct ieee80211vap *, int);
 	/* state machine processing */
 	int			(*iv_newstate)(struct ieee80211vap *,
 				    enum ieee80211_state, int);
@@ -603,7 +601,6 @@ MALLOC_DECLARE(M_80211_VAP);
 #define	IEEE80211_C_MONITOR	0x00010000	/* CAPABILITY: monitor mode */
 #define	IEEE80211_C_DFS		0x00020000	/* CAPABILITY: DFS/radar avail*/
 #define	IEEE80211_C_MBSS	0x00040000	/* CAPABILITY: MBSS available */
-#define IEEE80211_C_SWSLEEP	0x00080000	/* CAPABILITY: do sleep here */
 /* 0x7c0000 available */
 #define	IEEE80211_C_WPA1	0x00800000	/* CAPABILITY: WPA1 avail */
 #define	IEEE80211_C_WPA2	0x01000000	/* CAPABILITY: WPA2 avail */
diff --git a/sys/netproto/802_11/wlan/ieee80211.c b/sys/netproto/802_11/wlan/ieee80211.c
index f7bed22..5fea668 100644
--- a/sys/netproto/802_11/wlan/ieee80211.c
+++ b/sys/netproto/802_11/wlan/ieee80211.c
@@ -1359,8 +1359,7 @@ ieee80211_media_status(struct ifnet *ifp, struct ifmediareq *imr)
 	 * rate only when running; otherwise we may have a mismatch
 	 * in which case the rate will not be convertible.
 	 */
-	if (vap->iv_state == IEEE80211_S_RUN ||
-	    vap->iv_state == IEEE80211_S_SLEEP) {
+	if (vap->iv_state == IEEE80211_S_RUN) {
 		imr->ifm_status |= IFM_ACTIVE;
 		mode = ieee80211_chan2mode(ic->ic_curchan);
 	} else
diff --git a/sys/netproto/802_11/wlan/ieee80211_ioctl.c b/sys/netproto/802_11/wlan/ieee80211_ioctl.c
index 80e98a3..15a2815 100644
--- a/sys/netproto/802_11/wlan/ieee80211_ioctl.c
+++ b/sys/netproto/802_11/wlan/ieee80211_ioctl.c
@@ -600,7 +600,7 @@ ieee80211_ioctl_getcurchan(struct ieee80211vap *vap, struct ieee80211req *ireq)
 	 * in use.  When in RUN state report the vap-specific channel.
 	 * Otherwise return curchan.
 	 */
-	if (vap->iv_state == IEEE80211_S_RUN || vap->iv_state == IEEE80211_S_SLEEP)
+	if (vap->iv_state == IEEE80211_S_RUN)
 		c = vap->iv_bss->ni_chan;
 	else
 		c = ic->ic_curchan;
@@ -919,7 +919,7 @@ ieee80211_ioctl_get80211(struct ieee80211vap *vap, u_long cmd,
 	case IEEE80211_IOC_BSSID:
 		if (ireq->i_len != IEEE80211_ADDR_LEN)
 			return EINVAL;
-		if (vap->iv_state == IEEE80211_S_RUN || vap->iv_state == IEEE80211_S_SLEEP) {
+		if (vap->iv_state == IEEE80211_S_RUN) {
 			error = copyout(vap->iv_opmode == IEEE80211_M_WDS ?
 			    vap->iv_bss->ni_macaddr : vap->iv_bss->ni_bssid,
 			    ireq->i_data, ireq->i_len);
@@ -1010,7 +1010,7 @@ ieee80211_ioctl_get80211(struct ieee80211vap *vap, u_long cmd,
 	case IEEE80211_IOC_AMPDU_LIMIT:
 		if (vap->iv_opmode == IEEE80211_M_HOSTAP)
 			ireq->i_val = vap->iv_ampdu_rxmax;
-		else if (vap->iv_state == IEEE80211_S_RUN || vap->iv_state == IEEE80211_S_SLEEP)
+		else if (vap->iv_state == IEEE80211_S_RUN)
 			ireq->i_val = MS(vap->iv_bss->ni_htparam,
 			    IEEE80211_HTCAP_MAXRXAMPDU);
 		else
@@ -1018,7 +1018,7 @@ ieee80211_ioctl_get80211(struct ieee80211vap *vap, u_long cmd,
 		break;
 	case IEEE80211_IOC_AMPDU_DENSITY:
 		if (vap->iv_opmode == IEEE80211_M_STA &&
-		    (vap->iv_state == IEEE80211_S_RUN || vap->iv_state == IEEE80211_S_SLEEP))
+		    vap->iv_state == IEEE80211_S_RUN)
 			ireq->i_val = MS(vap->iv_bss->ni_htparam,
 			    IEEE80211_HTCAP_MPDUDENSITY);
 		else
@@ -1092,7 +1092,7 @@ ieee80211_ioctl_get80211(struct ieee80211vap *vap, u_long cmd,
 		break;
 	case IEEE80211_IOC_SMPS:
 		if (vap->iv_opmode == IEEE80211_M_STA &&
-		    (vap->iv_state == IEEE80211_S_RUN || vap->iv_state == IEEE80211_S_SLEEP)) {
+		    vap->iv_state == IEEE80211_S_RUN) {
 			if (vap->iv_bss->ni_flags & IEEE80211_NODE_MIMO_RTS)
 				ireq->i_val = IEEE80211_HTCAP_SMPS_DYNAMIC;
 			else if (vap->iv_bss->ni_flags & IEEE80211_NODE_MIMO_PS)
@@ -1104,7 +1104,7 @@ ieee80211_ioctl_get80211(struct ieee80211vap *vap, u_long cmd,
 		break;
 	case IEEE80211_IOC_RIFS:
 		if (vap->iv_opmode == IEEE80211_M_STA &&
-		    (vap->iv_state == IEEE80211_S_RUN || vap->iv_state == IEEE80211_S_SLEEP))
+		    vap->iv_state == IEEE80211_S_RUN)
 			ireq->i_val =
 			    (vap->iv_bss->ni_flags & IEEE80211_NODE_RIFS) != 0;
 		else
@@ -1858,7 +1858,7 @@ setcurchan(struct ieee80211vap *vap, struct ieee80211_channel *c)
 			if (IEEE80211_IS_CHAN_NOADHOC(c))
 				return EINVAL;
 		}
-		if ((vap->iv_state == IEEE80211_S_RUN || vap->iv_state == IEEE80211_S_SLEEP) &&
+		if (vap->iv_state == IEEE80211_S_RUN &&
 		    vap->iv_bss->ni_chan == c)
 			return 0;	/* NB: nothing to do */
 	}
diff --git a/sys/netproto/802_11/wlan/ieee80211_output.c b/sys/netproto/802_11/wlan/ieee80211_output.c
index 82c268e..5b02b20 100644
--- a/sys/netproto/802_11/wlan/ieee80211_output.c
+++ b/sys/netproto/802_11/wlan/ieee80211_output.c
@@ -135,17 +135,23 @@ ieee80211_start(struct ifnet *ifp, struct ifaltq_subque *ifsq)
 		ifsq_purge(ifsq);
 		return;
 	}
+	if (vap->iv_state == IEEE80211_S_SLEEP) {
+		/*
+		 * In power save, wakeup device for transmit.
+		 */
+		ieee80211_new_state(vap, IEEE80211_S_RUN, 0);
+		ifsq_purge(ifsq);
+		return;
+	}
 	/*
 	 * No data frames go out unless we're running.
 	 * Note in particular this covers CAC and CSA
 	 * states (though maybe we should check muting
 	 * for CSA).
 	 */
-	if (vap->iv_state != IEEE80211_S_RUN &&
-	    vap->iv_state != IEEE80211_S_SLEEP) {
+	if (vap->iv_state != IEEE80211_S_RUN) {
 		/* re-check under the com lock to avoid races */
-		if (vap->iv_state != IEEE80211_S_RUN &&
-		    vap->iv_state != IEEE80211_S_SLEEP) {
+		if (vap->iv_state != IEEE80211_S_RUN) {
 			IEEE80211_DPRINTF(vap, IEEE80211_MSG_OUTPUT,
 			    "%s: ignore queue, in %s state\n",
 			    __func__, ieee80211_state_name[vap->iv_state]);
@@ -264,21 +270,6 @@ ieee80211_start(struct ifnet *ifp, struct ifaltq_subque *ifsq)
 			}
 		}
 #endif
-		/*
-		 * We've resolved the sender, so attempt to transmit it.
-		 */
-		if (vap->iv_state == IEEE80211_S_SLEEP) {
-			/*
-			 * In power save; queue frame and then  wakeup device
-			 * for transmit.
-			 */
-			ic->ic_lastdata = ticks;
-			(void) ieee80211_pwrsave(ni, m);
-			ieee80211_free_node(ni);
-			ieee80211_new_state(vap, IEEE80211_S_RUN, 0);
-			continue;
-		}
-
 		if ((ni->ni_flags & IEEE80211_NODE_PWR_MGT) &&
 		    (m->m_flags & M_PWR_SAV) == 0) {
 			/*
diff --git a/sys/netproto/802_11/wlan/ieee80211_power.c b/sys/netproto/802_11/wlan/ieee80211_power.c
index 044bee6..2fdbf4d 100644
--- a/sys/netproto/802_11/wlan/ieee80211_power.c
+++ b/sys/netproto/802_11/wlan/ieee80211_power.c
@@ -70,8 +70,6 @@ ieee80211_power_vattach(struct ieee80211vap *vap)
 		vap->iv_update_ps = ieee80211_update_ps;
 		vap->iv_set_tim = ieee80211_set_tim;
 	}
-	vap->iv_node_ps = ieee80211_node_pwrsave;
-	vap->iv_sta_ps = ieee80211_sta_pwrsave;
 }
 
 void
@@ -541,87 +539,3 @@ ieee80211_sta_pwrsave(struct ieee80211vap *vap, int enable)
 		ieee80211_send_nulldata(ieee80211_ref_node(ni));
 	}
 }
-
-/*
- * Handle being notified that we have data available for us in a TIM/ATIM.
- *
- * This may schedule a transition from _SLEEP -> _RUN if it's appropriate.
- */
-void
-ieee80211_sta_tim_notify(struct ieee80211vap *vap, int set)
-{
-	/*
-	 * Schedule the driver state change.  It'll happen at some point soon.
-	 * Since the hardware shouldn't know that we're running just yet
-	 * (and thus tell the peer that we're awake before we actually wake
-	 * up said hardware), we leave the actual node state transition
-	 * up to the transition to RUN.
-	 *
-	 * XXX TODO: verify that the transition to RUN will wake up the
-	 * BSS node!
-	 */
-	IEEE80211_DPRINTF(vap, IEEE80211_MSG_POWER, "%s: TIM=%d\n", __func__, set);
-	if (set == 1 && vap->iv_state == IEEE80211_S_SLEEP) {
-		ieee80211_new_state_locked(vap, IEEE80211_S_RUN, 0);
-	}
-}
-
-/*
- * Timer check on whether the VAP has had any transmit activity.
- *
- * This may schedule a transition from _RUN -> _SLEEP if it's appropriate.
- */
-void
-ieee80211_sta_ps_timer_check(struct ieee80211vap *vap)
-{
-	struct ieee80211com *ic = vap->iv_ic;
-
-	/* XXX lock assert */
-
-	/* For no, only do this in STA mode */
-	if (! (vap->iv_caps & IEEE80211_C_SWSLEEP))
-		goto out;
-
-	if (vap->iv_opmode != IEEE80211_M_STA)
-		goto out;
-
-	/* If we're not at run state, bail */
-	if (vap->iv_state != IEEE80211_S_RUN)
-		goto out;
-
-	IEEE80211_DPRINTF(vap, IEEE80211_MSG_POWER,
-	    "%s: lastdata=%llu, ticks=%llu\n",
-	    __func__, (unsigned long long) ic->ic_lastdata,
-	    (unsigned long long) ticks);
-
-	/* If powersave is disabled on the VAP, don't bother */
-	if (! (vap->iv_flags & IEEE80211_F_PMGTON))
-		goto out;
-
-	/* If we've done any data within our idle interval, bail */
-	/* XXX hard-coded to one second for now, ew! */
-	if (time_after(ic->ic_lastdata + 500, ticks))
-		goto out;
-
-	/*
-	 * Signify we're going into power save and transition the
-	 * node to powersave.
-	 */
-	if ((vap->iv_bss->ni_flags & IEEE80211_NODE_PWR_MGT) == 0)
-		vap->iv_sta_ps(vap, 1);
-
-	/*
-	 * XXX The driver has to handle the fact that we're going
-	 * to sleep but frames may still be transmitted;
-	 * hopefully it and/or us will do the right thing and mark any
-	 * transmitted frames with PWRMGT set to 1.
-	 */
-	ieee80211_new_state_locked(vap, IEEE80211_S_SLEEP, 0);
-
-	IEEE80211_DPRINTF(vap, IEEE80211_MSG_POWER,
-	    "%s: time delta=%d msec\n", __func__,
-	    (int) ticks_to_msecs(ticks - ic->ic_lastdata));
-
-out:
-	return;
-}
diff --git a/sys/netproto/802_11/wlan/ieee80211_proto.c b/sys/netproto/802_11/wlan/ieee80211_proto.c
index a9b782e..12443e7 100644
--- a/sys/netproto/802_11/wlan/ieee80211_proto.c
+++ b/sys/netproto/802_11/wlan/ieee80211_proto.c
@@ -106,6 +106,8 @@ static void update_mcast_task(void *, int);
 static void update_promisc_task(void *, int);
 static void update_channel_task(void *, int);
 static void ieee80211_newstate_task(void *, int);
+static int ieee80211_new_state_locked(struct ieee80211vap *,
+	enum ieee80211_state, int);
 
 static int
 null_raw_xmit(struct ieee80211_node *ni, struct mbuf *m,
@@ -1706,7 +1708,7 @@ done:
  * is usually a mistake and indicates lack of proper integration
  * with the net80211 layer.
  */
-int
+static int
 ieee80211_new_state_locked(struct ieee80211vap *vap,
 	enum ieee80211_state nstate, int arg)
 {
diff --git a/sys/netproto/802_11/wlan/ieee80211_sta.c b/sys/netproto/802_11/wlan/ieee80211_sta.c
index d62d56a..8c25c96 100644
--- a/sys/netproto/802_11/wlan/ieee80211_sta.c
+++ b/sys/netproto/802_11/wlan/ieee80211_sta.c
@@ -225,7 +225,6 @@ sta_newstate(struct ieee80211vap *vap, enum ieee80211_state nstate, int arg)
 		switch (ostate) {
 		case IEEE80211_S_SLEEP:
 			/* XXX wakeup */
-			/* XXX driver hook to wakeup the hardware? */
 		case IEEE80211_S_RUN:
 			IEEE80211_SEND_MGMT(ni,
 			    IEEE80211_FC0_SUBTYPE_DISASSOC,
@@ -291,18 +290,12 @@ sta_newstate(struct ieee80211vap *vap, enum ieee80211_state nstate, int arg)
 			if (vap->iv_roaming == IEEE80211_ROAMING_AUTO)
 				ieee80211_check_scan_current(vap);
 			break;
-		case IEEE80211_S_SLEEP:		/* beacon miss */
-			/*
-			 * XXX if in sleep we need to wakeup the hardware.
-			 */
-			/* FALLTHROUGH */
 		case IEEE80211_S_RUN:		/* beacon miss */
 			/*
 			 * Beacon miss.  Notify user space and if not
 			 * under control of a user application (roaming
 			 * manual) kick off a scan to re-connect.
 			 */
-
 			ieee80211_sta_leave(ni);
 			if (vap->iv_roaming == IEEE80211_ROAMING_AUTO)
 				ieee80211_check_scan_current(vap);
@@ -401,8 +394,7 @@ sta_newstate(struct ieee80211vap *vap, enum ieee80211_state nstate, int arg)
 			    arg == IEEE80211_FC0_SUBTYPE_ASSOC_RESP);
 			break;
 		case IEEE80211_S_SLEEP:
-			/* Wake up from sleep */
-			vap->iv_sta_ps(vap, 0);
+			ieee80211_sta_pwrsave(vap, 0);
 			break;
 		default:
 			goto invalid;
@@ -429,11 +421,9 @@ sta_newstate(struct ieee80211vap *vap, enum ieee80211_state nstate, int arg)
 			ieee80211_node_authorize(ni);
 		/*
 		 * Fake association when joining an existing bss.
-		 *
-		 * Don't do this if we're doing SLEEP->RUN.
 		 */
-		if (ic->ic_newassoc != NULL && ostate != IEEE80211_S_SLEEP)
-			ic->ic_newassoc(vap->iv_bss, (ostate != IEEE80211_S_RUN));
+		if (ic->ic_newassoc != NULL)
+			ic->ic_newassoc(vap->iv_bss, ostate != IEEE80211_S_RUN);
 		break;
 	case IEEE80211_S_CSA:
 		if (ostate != IEEE80211_S_RUN)
@@ -1351,40 +1341,23 @@ sta_recv_mgmt(struct ieee80211_node *ni, struct mbuf *m0,
 				    scan.htcap, scan.htinfo);
 				/* XXX state changes? */
 			}
-
 			if (scan.tim != NULL) {
 				struct ieee80211_tim_ie *tim =
 				    (struct ieee80211_tim_ie *) scan.tim;
-				/*
-				 * XXX Check/debug this code; see if it's about
-				 * the right time to force the VAP awake if we
-				 * receive a frame destined for us?
-				 */
+#if 0
 				int aid = IEEE80211_AID(ni->ni_associd);
 				int ix = aid / NBBY;
 				int min = tim->tim_bitctl &~ 1;
 				int max = tim->tim_len + min - 4;
-
-				/*
-				 * Only do this for unicast traffic in the TIM
-				 * The multicast traffic notification for
-				 * the scan notification stuff should occur
-				 * differently.
-				 */
-				if (min <= ix && ix <= max &&
-				    isset(tim->tim_bitmap - min, aid)) {
-					ieee80211_sta_tim_notify(vap, 1);
-					ic->ic_lastdata = ticks;
-				}
-
-				/*
-				 * XXX TODO: do a separate notification
-				 * for the multicast bit being set.
-				 */
-#if 0
-				if (tim->tim_bitctl & 1) {
-					ieee80211_sta_tim_notify(vap, 1);
+				if ((tim->tim_bitctl&1) ||
+				    (min <= ix && ix <= max &&
+				     isset(tim->tim_bitmap - min, aid))) {
+					/* 
+					 * XXX Do not let bg scan kick off
+					 * we are expecting data.
+					 */
 					ic->ic_lastdata = ticks;
+					ieee80211_sta_pwrsave(vap, 0);
 				}
 #endif
 				ni->ni_dtim_count = tim->tim_count;
@@ -1429,16 +1402,8 @@ sta_recv_mgmt(struct ieee80211_node *ni, struct mbuf *m0,
 #endif
 				ieee80211_bg_scan(vap, 0);
 			}
-
-			/*
-			 * Put the station to sleep if we haven't seen
-			 * traffic in a while.
-			 */
-			ieee80211_sta_ps_timer_check(vap);
-
 			return;
 		}
-
 		/*
 		 * If scanning, just pass information to the scan module.
 		 */
-- 
1.8.4.1

